(* Copyright 2011 Cornell University
 *
 *
 * This file is part of EventML - a tool aiming at specifying
 * distributed protocols in an ML like language.  It is an interface
 * to the logic of events and is compiled into Nuprl.  It is written
 * by the NUPRL group of Cornell University, Ithaca, NY.
 *
 * EventML is a free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EventML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventML.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  o Authors:     Vincent Rahli
 *  o Affiliation: Cornell University, NUPRL group
 *  o Date:        29 July 2011
 *  o File name:   EvalProperties.sml
 *  o Description: Some properties of terms.
 *)


structure EvalProperties :> EVAL_PROPERTIES = struct

structure B = Tools

fun is_eval_all id = B.member id ["callbyvalueall","eq_term"]

fun num_principals id =
    if B.member id ["!abstraction"]
    then 3
    else if B.member id ["add","subtract","multiply","divide","remainder","less",
			 "int_eq","atom_eq","eq_term"]
    then 2
    else if B.member id ["limited_type_case","minus","isinr","isinl","ispair",
			 "isint","islambda","isatom2","spread","decide","apply",
			 "callbyvalue","callbyvalueall","list_ind","ind"]
    then 1
    else 0

fun num_principal_all id =
    if B.member id ["equal"]
    then 3
    else if B.member id ["pair","cons","union","subtype_rel"]
    then 2
    else if B.member id ["inl","inr","list"]
    then 1
    else if B.member id ["function","product","isect","tunion","set","quotient"]
    then 1
    else 0

end
