(* Copyright 2011 Cornell University
 *
 *
 * This file is part of EventML - a tool aiming at specifying
 * distributed protocols in an ML like language.  It is an interface
 * to the logic of events and is compiled into Nuprl.  It is written
 * by the NUPRL group of Cornell University, Ithaca, NY.
 *
 * EventML is a free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * EventML is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventML.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  o Authors:     Vincent Rahli
 *  o Affiliation: Cornell University, NUPRL group
 *  o Date:        20 May 2011
 *  o File name:   Evaluators.sig
 *  o Description: .
 *)


signature EVALUATOR = sig

    val bunch_of_terms : (string * NuprlTerms.nuprl_term) list

    val Evaluator1     : int                   ->
			 NuprlTerms.nuprl_term ->
			 NuprlTerms.nuprl_term * int

    (*val Evaluator2     : int -> term -> term * int
    val Evaluator3     : int -> term -> term * int
    val Evaluator4     : int -> term -> term * int*)

    val run_ev1        : bool                  ->
			 string option         ->
			 (NuprlTerms.nuprl_term * NuprlTerms.nuprl_term) list ->
			 int                   ->
			 NuprlTerms.nuprl_term ->
			 NuprlTerms.nuprl_term * int

    val run_ev1_map    : (NuprlTerms.nuprl_term * NuprlTerms.nuprl_term) list ->
			 int                   ->
			 NuprlTerms.nuprl_term ->
			 NuprlTerms.nuprl_term * int

    val start_session  : bool          -> (*true to get debug info*)
			 string option ->
			 unit

    val end_session    : unit -> unit

    val test           : int -> unit

end
